# -*- coding: utf-8 -*-
from Tkinter import *
import Image, ImageTk, urllib, tkMessageBox, random, os, urllib2, tkSimpleDialog
from threading import Thread
from xml.dom import minidom



def vrat_souradnice(x, y, priblizeni):
    souradnice = []
    yrozsah = 2*(2**priblizeni)
    xrozsah = 3*(2**priblizeni)
    if x < xrozsah and y < yrozsah and x >= 0 and y >= 0 and priblizeni <= 9 and priblizeni >= 0:
        souradnice.append((x, y, 0, 0))
    else:
        return []
    
    for xplus, yplus in [[-1, 0], [-1, -1], [0, -1], [1, -1], [1, 0], [1, 1], [0, 1], [-1, 1]]:
        xnew, ynew = x+xplus, y+yplus
        if xnew < xrozsah and xnew >= 0 and ynew < yrozsah and ynew >= 0:
            souradnice.append((xnew, ynew, xplus, yplus))

    
    return souradnice


def save_img(url, name):
    do = True
    while do:
        image = urllib.URLopener()
        image.retrieve(url, "images/"+name)
        try:
            img = Image.open("images/"+name)
            do = False
        except IOError:
            pass






class zobrazovac(Thread):
    def __init__(s, self, xs, ys, priblizeni, posx, posy):
        Thread.__init__(s)
        s.self = self
        s.x = xs
        s.y = ys
        s.p = priblizeni
        s.posx = posx
        s.posy = posy
        
        
    
    def run(s):
        do = True
        while do:        
            try:
                s.self.zobraz_jeden(s.x, s.y, s.p, s.posx, s.posy)
                do = False
            except IOError:
                pass





class App:
    def __init__(self):
        self.images = []
        self.root = Tk()

        self.mesta = None

        self.x = None
        self.y = None
        self.p = None


        self.root.bind("<Up>", self.roll_up)
        self.root.bind("<Down>", self.roll_down)
        self.root.bind("<Left>", self.roll_left)
        self.root.bind("<Right>", self.roll_right)

        self.root.bind("<q>", self.zoom_in)
        self.root.bind("<w>", self.zoom_out)

        #programování GUI
        self.main_frame = Frame(self.root)
        self.main_frame.pack(fill=X)

        Label(self.main_frame, text="X:").pack(side=LEFT)
        self.xentry = Entry(self.main_frame)
        self.xentry.pack(side=LEFT)

        Label(self.main_frame, text="Y:").pack(side=LEFT)
        self.yentry = Entry(self.main_frame)
        self.yentry.pack(side=LEFT)

        Label(self.main_frame, text="Přiblížení:").pack(side=LEFT)
        self.priblizeni = Entry(self.main_frame)
        self.priblizeni.pack(side=LEFT)
        

        
        Button(self.main_frame, text="Zobraz", command = self.zobraz).pack(side=LEFT)
        Button(self.main_frame, text="Help", command = self.show_info).pack(side=LEFT)
        
        self.mesto_frame = Frame(self.root)
        self.mesto_frame.pack(fill=X)

        Label(self.mesto_frame, text="Hledej město:").pack(side=LEFT)
        self.mesto = Entry(self.mesto_frame)
        self.mesto.pack(side=LEFT)

        Button(self.mesto_frame, text="Hledej", command = self.hledej_mesto).pack(side=LEFT)




        self.canvas = Canvas(self.root, bg = "black", width=600, height=600)
        self.canvas.pack()


        self.root.mainloop()


    def stahni_mesta(self):
        data = urllib2.urlopen("http://192.168.2.76:" + str(random.randint(8002, 8020)) +"/obce.xml").read()
        mesta_doc = minidom.parseString(data)
        self.mesta = []
        for mesto in mesta_doc.getElementsByTagName("obec"):
            self.mesta.append({"jmeno":mesto.getAttribute(u"jméno").lower(), "x":int(mesto.getAttribute("x")), "y":int(mesto.getAttribute("y"))})
        
        
        


    def hledej_mesto(self):
        mesto = self.mesto.get().strip().lower()
        
        if self.mesta == None:
            self.stahni_mesta()


        nalezena_mesta = []

        for i, dic in enumerate(self.mesta):
            if dic["jmeno"] == mesto:
                nalezena_mesta.append(i)

        if not nalezena_mesta:
            tkMessageBox.showinfo("Nenalezeno", "Město nenalezeno!")
            return

        print nalezena_mesta
        zvolene = nalezena_mesta[0]
        if len(nalezena_mesta) > 1:
            prompt = ""
            for i, index in enumerate(nalezena_mesta):
                prompt += str(i+1) + ": " + self.mesta[index]["jmeno"]+"\n"
                
            zvolene = tkSimpleDialog.askinteger("Zvolte město", prompt)
            if zvolene not in range(1, len(nalezena_mesta)+1):
                return
            zvolene = nalezena_mesta[zvolene-1]
                
        
        dic = self.mesta[zvolene]
        try:
            priblizeni = int(self.priblizeni.get())
        except ValueError:
            priblizeni = 9
        if priblizeni not in range(0, 10):
            priblizeni = 9
                
        xnew = (dic["x"]/256)/(2**(9-priblizeni))
        ynew = dic["y"]/256/(2**(9-priblizeni))

        self.x = xnew
        self.y = ynew

        self.xentry.delete(0, END)
        self.xentry.insert(0, str(self.x))
        self.yentry.delete(0, END)
        self.yentry.insert(0, str(self.y))
        self.priblizeni.delete(0, END)
        self.priblizeni.insert(0, str(priblizeni))
        self.zobraz()

                
                



    def zoom_in(self, spam):
        if self.p == None:
            return
        souradnice = vrat_souradnice(self.x*2, self.y*2, self.p+1)
        if souradnice:
            self.p += 1
            self.x *= 2
            self.y *= 2
            self.priblizeni.delete(0, END)
            self.priblizeni.insert(0, str(self.p))
            self.xentry.delete(0, END)
            self.xentry.insert(0, str(self.x))
            self.yentry.delete(0, END)
            self.yentry.insert(0, str(self.y))
                
            self.zobraz()
            


    def zoom_out(self, spam):
        if self.p == None:
            return
        souradnice = vrat_souradnice(self.x/2, self.y/2, self.p-1)
        if souradnice:
            self.p -= 1
            self.x /= 2
            self.y /= 2
            self.priblizeni.delete(0, END)
            self.priblizeni.insert(0, str(self.p))
            self.xentry.delete(0, END)
            self.xentry.insert(0, str(self.x))
            self.yentry.delete(0, END)
            self.yentry.insert(0, str(self.y))
                
            self.zobraz()
            


    def roll_up(self, spam):
        self.roll(0, -1)

    def roll_down(self, spam):
        self.roll(0, 1)

    def roll_left(self, spam):
        self.roll(-1, 0)

    def roll_right(self, spam):
        self.roll(1, 0)

    def roll(self, xplus, yplus):
        if self.x != None and self.y != None:                
            xnew = self.x+xplus
            ynew = self.y+yplus
            souradnice = vrat_souradnice(xnew, ynew, self.p)
            if souradnice:
                self.xentry.delete(0, END)
                self.xentry.insert(0, str(xnew))
                self.yentry.delete(0, END)
                self.yentry.insert(0, str(ynew))
                self.zobraz()


    def show_info(self):
        info = """Posouvání v mapě: Šipky (Nahoru, dolu, doleva, doprava)
Přibližování a oddalování: Klávesy Q (přiblížení) a W (oddálení)"""
        tkMessageBox.showinfo("Info", info)


    def zobraz(self):
        self.canvas.focus_set()
        try:                
            x = int(self.xentry.get())
            y = int(self.yentry.get())
            priblizeni = int(self.priblizeni.get())
        except ValueError:
            tkMessageBox.showerror(title="Špatné souřadnice", message="Neplatný Formát zadaných souřadnic")
            return

        
        
        
        souradnice = vrat_souradnice(x, y, priblizeni)


        if souradnice:
            self.x = x
            self.y = y
            self.p = priblizeni
            self.canvas.delete(ALL)
            for xs, ys, xplus, yplus in souradnice:
                z = zobrazovac(self, xs, ys, priblizeni, 300+(xplus*200), 300+(yplus*200))
                z.start()
                
            

        else:
            tkMessageBox.showerror(title="Špatné souřadnice", message="Neplatný Formát zadaných souřadnic")


    def zobraz_jeden(self, x, y, p, posx, posy):
        name = str(p)+"-"+str(x)+"-"+str(y)+".jpg"
        if not os.path.exists("images/"+name):
            url = "http://192.168.2.76:" + str(random.randint(8002, 8020)) + "/" + str(p) + "/" + str(x) + "/" + str(y) + ".jpg"
            save_img(url, name)
        
        self.canvas.create_image(posx, posy, image = self.get_image(name))



    def get_image(self, name):
        img = Image.open("images/"+name)
        img = img.resize((200, 200))
        img = ImageTk.PhotoImage(img)
        self.images.append(img)
        return img



        
a = App()
